PBESecretKeyFactory (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.jcajce.provider.symmetric.util

## Class PBESecretKeyFactory

- java.lang.Object
- - javax.crypto.SecretKeyFactorySpi
  - - org.bouncycastle.jcajce.provider.symmetric.util.BaseSecretKeyFactory
    - - org.bouncycastle.jcajce.provider.symmetric.util.PBESecretKeyFactory

- All Implemented Interfaces:
    PBE
  Direct Known Subclasses:
    AES.PBEWithMD5And128BitAESCBCOpenSSL, AES.PBEWithMD5And192BitAESCBCOpenSSL, AES.PBEWithMD5And256BitAESCBCOpenSSL, AES.PBEWithSHA256And128BitAESBC, AES.PBEWithSHA256And192BitAESBC, AES.PBEWithSHA256And256BitAESBC, AES.PBEWithSHAAnd128BitAESBC, AES.PBEWithSHAAnd192BitAESBC, AES.PBEWithSHAAnd256BitAESBC, ARC4.PBEWithSHAAnd128BitKeyFactory, ARC4.PBEWithSHAAnd40BitKeyFactory, GOST3411.PBEWithMacKeyFactory, IDEA.PBEWithSHAAndIDEAKeyGen, RC2.PBEWithMD2KeyFactory, RC2.PBEWithMD5KeyFactory, RC2.PBEWithSHA1KeyFactory, RC2.PBEWithSHAAnd128BitKeyFactory, RC2.PBEWithSHAAnd40BitKeyFactory, RIPEMD160.PBEWithHmacKeyFactory, SHA1.PBEWithMacKeyFactory, SHA256.PBEWithMacKeyFactory, Tiger.PBEWithMacKeyFactory, Twofish.PBEWithSHAKeyFactory

      public class PBESecretKeyFactory
      extends BaseSecretKeyFactory
      implements PBE

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.bouncycastle.jcajce.provider.symmetric.util.PBE

      `PBE.Util`

  - ### Field Summary

    - ### Fields inherited from class org.bouncycastle.jcajce.provider.symmetric.util.BaseSecretKeyFactory

      `algName, algOid`

    - ### Fields inherited from interface org.bouncycastle.jcajce.provider.symmetric.util.PBE

      `GOST3411, MD2, MD5, OPENSSL, PKCS12, PKCS5S1, PKCS5S1_UTF8, PKCS5S2, PKCS5S2_UTF8, RIPEMD160, SHA1, SHA256, TIGER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PBESecretKeyFactory(java.lang.String algorithm, ASN1ObjectIdentifier oid, boolean forCipher, int scheme, int digest, int keySize, int ivSize)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected javax.crypto.SecretKey` | `engineGenerateSecret(java.security.spec.KeySpec keySpec)`

    - ### Methods inherited from class org.bouncycastle.jcajce.provider.symmetric.util.BaseSecretKeyFactory

      `engineGetKeySpec, engineTranslateKey`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PBESecretKeyFactory

          public PBESecretKeyFactory(java.lang.String algorithm,
                             ASN1ObjectIdentifier oid,
                             boolean forCipher,
                             int scheme,
                             int digest,
                             int keySize,
                             int ivSize)

  - ### Method Detail

    - #### engineGenerateSecret

          protected javax.crypto.SecretKey engineGenerateSecret(java.security.spec.KeySpec keySpec)
                                                         throws java.security.spec.InvalidKeySpecException

      Overrides:
        `engineGenerateSecret` in class `BaseSecretKeyFactory`
      Throws:
        `java.security.spec.InvalidKeySpecException`